package com.example.user.myapp;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;

public class MainActivity extends AppCompatActivity {

    // constant for extra in intent
    private static final String EXTRA_IP_ADDRESS = "extra.ip.address";
    private static final String EXTRA_IP_PORT = "extra.ip.port";
    private static final String EXTRA_REF = "extra.ref";
    private static final String EXTRA_COUNT = "extra.count";
    private static final String EXTRA_INTENT_NAME = "extra.intent.name";

    // constant for action name
    private static final String ACTION_READ_COIL = "read.coil";
    private static final String ACTION_READ_DISCRETE_INPUT = "read.discrete.input";
    private static final String ACTION_READ_INPUT_REGISTER = "read.input.register";


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_main);
    }

    /** Called when the user taps the Send button */
    public void sendMessage(View view) {
        //EditText editText1 = (EditText) findViewById(R.id.ipAddress);
        //String ipAddress = editText1.getText().toString();
        //String ipAddress = "172.16.202.14";

        String ipAddress = "192.168.157.16";
        int port = 503;

        //EditText editText2 = (EditText) findViewById(R.id.port);
        //int port = Integer.parseInt(editText2.getText().toString());

        GlobalState state = (GlobalState) getApplicationContext();
        state.setIpAddress(ipAddress);
        state.setPort(port);

        // read only
        Intent coilServiceIntent = new Intent(this, MyIntentService.class);
        coilServiceIntent.setAction(ACTION_READ_COIL);
        coilServiceIntent.putExtra(EXTRA_IP_ADDRESS, ipAddress);
        coilServiceIntent.putExtra(EXTRA_IP_PORT, port);
        coilServiceIntent.putExtra(EXTRA_REF, GlobalState.InputConfig.Q_COIL.getStartReference());
        coilServiceIntent.putExtra(EXTRA_COUNT, GlobalState.InputConfig.Q_COIL.getCount());
        coilServiceIntent.putExtra(EXTRA_INTENT_NAME, "readOnlyCoil");
        this.startService(coilServiceIntent);

        Intent discretInputserviceIntent = new Intent(this, MyIntentService.class);
        discretInputserviceIntent.setAction(ACTION_READ_DISCRETE_INPUT);
        discretInputserviceIntent.putExtra(EXTRA_IP_ADDRESS, ipAddress);
        discretInputserviceIntent.putExtra(EXTRA_IP_PORT, port);
        discretInputserviceIntent.putExtra(EXTRA_REF, GlobalState.InputConfig.I_DI.getStartReference());
        discretInputserviceIntent.putExtra(EXTRA_COUNT, GlobalState.InputConfig.I_DI.getCount());
        discretInputserviceIntent.putExtra(EXTRA_INTENT_NAME, "readOnlyDiscreteInput");
        this.startService(discretInputserviceIntent);

        Intent inputRegisterServiceIntent = new Intent(this, MyIntentService.class);
        inputRegisterServiceIntent.setAction(ACTION_READ_INPUT_REGISTER);
        inputRegisterServiceIntent.putExtra(EXTRA_IP_ADDRESS, ipAddress);
        inputRegisterServiceIntent.putExtra(EXTRA_IP_PORT, port);
        inputRegisterServiceIntent.putExtra(EXTRA_REF, GlobalState.InputConfig.AI_IR.getStartReference());
        inputRegisterServiceIntent.putExtra(EXTRA_COUNT, GlobalState.InputConfig.AI_IR.getCount());
        inputRegisterServiceIntent.putExtra(EXTRA_INTENT_NAME, "readOnlyInputRegister");
        this.startService(inputRegisterServiceIntent);


        Intent vmCoil2ServiceIntent = new Intent(this, MyIntentService.class);
        vmCoil2ServiceIntent.setAction(ACTION_READ_COIL);
        vmCoil2ServiceIntent.putExtra(EXTRA_IP_ADDRESS, ipAddress);
        vmCoil2ServiceIntent.putExtra(EXTRA_IP_PORT, port);
        vmCoil2ServiceIntent.putExtra(EXTRA_REF, GlobalState.InputConfig.VM_COIL2.getStartReference());
        vmCoil2ServiceIntent.putExtra(EXTRA_COUNT, GlobalState.InputConfig.VM_COIL2.getCount());
        vmCoil2ServiceIntent.putExtra(EXTRA_INTENT_NAME, "readVmCoil2");
        this.startService(vmCoil2ServiceIntent);

        Intent vmCoil3ServiceIntent = new Intent(this, MyIntentService.class);
        vmCoil3ServiceIntent.setAction(ACTION_READ_COIL);
        vmCoil3ServiceIntent.putExtra(EXTRA_IP_ADDRESS, ipAddress);
        vmCoil3ServiceIntent.putExtra(EXTRA_IP_PORT, port);
        vmCoil3ServiceIntent.putExtra(EXTRA_REF, GlobalState.InputConfig.VM_COIL3.getStartReference());
        vmCoil3ServiceIntent.putExtra(EXTRA_COUNT, GlobalState.InputConfig.VM_COIL3.getCount());
        vmCoil3ServiceIntent.putExtra(EXTRA_INTENT_NAME, "readVmCoil3");
        this.startService(vmCoil3ServiceIntent);

        Intent nextIntent = new Intent(this, DisplayMessageActivity.class);
        this.startActivity(nextIntent);
    }
}

