package com.example.user.myapp;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Handler;
import android.support.v4.content.LocalBroadcastManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.ToggleButton;

public class ManualDriveActivity extends AppCompatActivity {
    private GlobalState state;
    private Handler coilHandler;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        LocalBroadcastManager.getInstance(this).registerReceiver(coilWriterMessageReceiver, new IntentFilter("readVmCoil2"));
        LocalBroadcastManager.getInstance(this).registerReceiver(coilWriterMessageReceiver, new IntentFilter("checkCoilValue"));

        state = (GlobalState) getApplicationContext();

        coilHandler = new Handler();
    //    coilHandler.post(refreshCoil);


        setContentView(R.layout.activity_manual_drive);

        ToggleButton button = (ToggleButton) findViewById(R.id.h1_control_button);
        button.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    // writing the value true
                    Intent serviceIntent = new Intent(getApplicationContext(), MyIntentService.class);
                    serviceIntent.setAction("write.coil");
                    serviceIntent.putExtra("extra.ip.address", state.getIpAddress());
                    serviceIntent.putExtra("extra.ip.port", state.getPort());
                    serviceIntent.putExtra("extra.ref", GlobalState.InputConfig.VM_COIL2.getStartReference());
                    serviceIntent.putExtra("extra.bit", true);
                    serviceIntent.putExtra("extra.intent.name", "readVmCoil2");
                    getApplicationContext().startService(serviceIntent);
                } else {
                    // writing the value false
                    Intent serviceIntent = new Intent(getApplicationContext(), MyIntentService.class);
                    serviceIntent.setAction("write.coil");
                    serviceIntent.putExtra("extra.ip.address", state.getIpAddress());
                    serviceIntent.putExtra("extra.ip.port", state.getPort());
                    serviceIntent.putExtra("extra.ref", GlobalState.InputConfig.VM_COIL2.getStartReference());
                    serviceIntent.putExtra("extra.bit", false);
                    serviceIntent.putExtra("extra.intent.name", "readVmCoil2");
                    getApplicationContext().startService(serviceIntent);
                }
            }
        });
    }

    private BroadcastReceiver coilWriterMessageReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            boolean supposedToBeValue = intent.getBooleanExtra("coil", false);

            ImageView lightOn = (ImageView) findViewById(R.id.h1_status_light_on);
            ImageView lightOff = (ImageView) findViewById(R.id.h1_status_light_off);

            if (supposedToBeValue) {
                lightOn.setVisibility(View.VISIBLE);
                lightOff.setVisibility(View.INVISIBLE);
            } else {
                lightOn.setVisibility(View.INVISIBLE);
                lightOff.setVisibility(View.VISIBLE);
            }
        }
    };
}
